<?php
/*
Plugin Name: WordPress AdBlock Blocker
Plugin URI: http://regentware.com/wordpress-adblock-blocker/
Description: The WordPress AdBlocker Blocker is designed for one purpose, to block visitors to your website who use FireFox AdBlocker.
Author: Christopher Ross
Version: 0.1.02
Author URI: http://christopherross.ca
*/


/*
	/--------------------------------------------------------------------\
	|                                                                    |
	| License: GPL                                                       |
	|                                                                    |
	| Copyright (C) 2010, Christopher Ross			  	   			     |
	| http://christopherross.ca	                                         |
	| All rights reserved.                                               |
	|                                                                    |
	| This program is free software; you can redistribute it and/or      |
	| modify it under the terms of the GNU General Public License        |
	| as published by the Free Software Foundation; either version 2     |
	| of the License, or (at your option) any later version.             |
	|                                                                    |
	| This program is distributed in the hope that it will be useful,    |
	| but WITHOUT ANY WARRANTY; without even the implied warranty of     |
	| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      |
	| GNU General Public License for more details.                       |
	|                                                                    |
	| You should have received a copy of the GNU General Public License  |
	| along with this program; if not, write to the                      |
	| Free Software Foundation, Inc.                                     |
	| 51 Franklin Street, Fifth Floor                                    |
	| Boston, MA  02110-1301, USA                                        |   
	|                                                                    |
	\--------------------------------------------------------------------/
*/




/* 	Plugin settings */
global $cr_wp_ab_slug_name;
global $cr_wp_ab_admin_menu;
global $cr_wp_ab_admin_level;


$sitename 				= "http://regentware.com/";
$cr_wp_ab_name 			= 'AdBlock Blocker';
$cr_wp_ab_file_name		= 'wordpress-adblock-blocker';
$cr_wp_ab_slug_name		= str_replace('-','_',$cr_wp_ab_file_name);
$cr_wp_ab_url			= $sitename.$cr_wp_ab_file_name.'/';
$cr_wp_ab_docs			= $sitename.$cr_wp_ab_file_name.'/';
//$cr_wp_ab__pro		= $sitename.$cr_wp_ab_file_name.'/';
$cr_wp_ab_forum			= 'http://wordpress.org/tags/wordpress-adblock-blocker?forum_id=10';
$cr_wp_ab_donate		= 'http://regentware.com/free-downloads/?url='.str_rot13('http://regentware.com/downloads='.$cr_wp_ab_slug_name);
$cr_wp_ab_updateurl		= 'http://feeds.feedburner.com/thisismyurl?format=xml';
$cr_wp_ab_admin_level 	= 10;
$cr_wp_ab_admin_menu 	= 'tools';

$cr_wp_ab_admin_credits	= "	<ul><li>$cr_wp_ab_name plugin development by <a href='http://christopherross.ca'>Christopher Ross</a>.</li></ul>";
							
include('common/cr-common.php');



if(eregi("google",$_SERVER['HTTP_USER_AGENT'])) {} else {
add_action('wp_head', 'cr_wp_ab_site_header_code');
}

function cr_wp_ab_site_header_code() {
	global $post;
	global $cr_wp_ab_file_name;
	global $cr_wp_ab_slug_name;
	
	
	$redirect = get_option($cr_wp_ab_slug_name.'_redirect');
	$redirect = str_replace('http://','',$redirect);
	$redirect = str_replace('https://','',$redirect);
	
	$url = $_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];
	if ($url != $redirect) {
?>
		<script type="text/javascript">
            var adblock = true;
        </script>
        <script type="text/javascript" src="<?php bloginfo('url'); ?>/wp-content/plugins/<?php echo $cr_wp_ab_file_name;?>/adframe.js"></script>
        <script type="text/javascript">
            if(adblock) {
               window.location = "<?php bloginfo('url'); ?>/blocked/"
            }
        </script>
<?php }
}



function wordpress_adblock_blocker_option() {	

	cr_wp_ab_option_top();

	
	echo "<div class='accordionButton'><strong>Settings</strong></div>";
	echo "<div class='accordionContent phpinfo'>";
	echo "<table class='form-table'>";

	
	echo cr_wp_ab_admin_build_option("Redirect URL for Blocked Users", "_redirect", "Where would you like to redirect blocked visits? (full URL with http://)", "text", "");

	
	echo "</table>";
	echo "</div>";


	cr_wp_ab_option_bottom();
	
}



?>